/* Sostituto controller seriale MC68B50 - bus RC2014
 * scritto da Michele Dalla Silvestra (2023)
 * software rilasciato con licenza GNU GPL 3
 * 
 * Seriale principale forzata a 115200 8N1
 * porta IO di controllo 0x80
 * porta IO di invio/ricezione 0x81
 */

void setup() {
  Serial.begin(9600);
  attachInterrupt(digitalPinToInterrupt(2),int_pin_wr,FALLING);  // WR
  attachInterrupt(digitalPinToInterrupt(3),int_pin_rd,CHANGE); // RD
}

int int_da_gestire=0;

void int_pin_rd() {
//  if (digitalRead(A1)!=0)
  if ((PINF&0x02)!=0)
  {
    DDRL=0;
    PORTL=0;
  }
  else
  {
//    if (digitalRead(A0)==0)
    if ((PINF&0x01)==0)
    {
      if (PINC==0x80)
      {
        DDRL=0xff;
        if (Serial.available())
          PORTL=0b00000011;
        else
          PORTL=0b00000010;
      }
      if ((PINC==0x81) && Serial.available())
      {
        DDRL=0xff;
        PORTL=Serial.read();
        int_da_gestire=0;
      }
    }
  }
}

void int_pin_wr() {
//  if ((digitalRead(A0)==0) && (digitalRead(A2)==0))
  if ((PINF&0x05)==0)
  {
    if (PINC==0x81)
    {
      Serial.write(PINL);
    }
  }
}

void loop() {
  if ((int_da_gestire==0) && Serial.available())
  {
    int_da_gestire=1;
    DDRF=0x10;
//    pinMode(A4,OUTPUT); // INT
//    digitalWrite(A4,0);
    for (int i=0; ((i<500) && ((PINF&0x81)!=0)); i++) // M1 IOreq
//    for (int i=0; ((i<500) && ((digitalRead(A7)==1) || digitalRead(A0)==1)); i++) // M1 IOreq
      delayMicroseconds(100);
    DDRF=0x00;
//    pinMode(A4,INPUT); // INT
  }
}
