/* Monitoraggio segnali bus Z80 - RC2014
 * scritto da Michele Dalla Silvestra (2023)
 * software rilasciato con licenza GNU GPL 3
 * 
 * Trasmette sulla porta seriale (verso il pc) i principali
 * comandi di lettura/scrittura verso memoria e dispositivi
 */

void setup() {
  delay(2000);
  Serial.begin(115200);
  Serial.println("Z80 RC2014 monitor bus 01/11/2023");
  Serial.println();
  delay(2000);
  attachInterrupt(digitalPinToInterrupt(2),printbus,CHANGE);  // WR
  attachInterrupt(digitalPinToInterrupt(3),printbus,CHANGE);  // RD
}

void printhex(byte h)
{
  if (h>9) h+=7;
  Serial.write(48+h);
}

void printbyte(byte b)
{
  printhex(b>>4);
  printhex(b&0xf);
}

void printbyte_real(byte b)
{
  for (byte i=0; i<8; i++,b<<=1)
    if ((b&0x80)!=0)
      Serial.print('1');
    else
      Serial.print('0');
}


void printbus() {
  Serial.print("A ");
  printbyte(PINA);
//  Serial.print(' ');
  printbyte(PINC);
  Serial.print(" D ");
  printbyte(PINL);
  if (digitalRead(A1)==0)
    Serial.print(" RD");
  if (digitalRead(A2)==0)
    Serial.print(" WR");
  if (digitalRead(A0)==0)
    Serial.print(" IOreq");
  if (digitalRead(A3)==0)
    Serial.print(" Mreq");
  if (digitalRead(A6)==0)
    Serial.print(" RESET");
  if (digitalRead(A7)==0)
    Serial.print(" M1");
  if (digitalRead(A8)==0)
    Serial.print(" Refresh");
  Serial.println();
}

void loop() {
}
